/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.wahlbeteiligung.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractWahlbeteiligungVerlaufGebietSearch {

  @Inject
  protected transient WahlbeteiligungVerlaufGebietExtendedDAO dao;

  public AbstractWahlbeteiligungVerlaufGebietSearch() {
    super();
  }

  public List<WahlbeteiligungVerlaufGebiet> getSearchResult(WahlbeteiligungVerlaufGebietSearchParameters searchParameters, EagerLoadingCollector<WahlbeteiligungVerlaufGebiet> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<WahlbeteiligungVerlaufGebiet> querySearchResult(WahlbeteiligungVerlaufGebietSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
